package com.mayank.training.workflow;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.util.List;

import org.drools.runtime.process.ProcessInstance;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.TaskService;
import org.jbpm.task.service.local.LocalTaskService;
import org.junit.Before;
import org.junit.Test;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.mayank.training.jbpm.services.WorkflowService;
import com.mayank.training.jbpm.services.WorkflowServiceImpl;


public class WorkflowIntegrityTest {
	
	static ApplicationContext context;
	private LocalTaskService localTaskService;
	private WorkflowService workflowService;
	
	
	@Before
	public void setUp(){
		System.setProperty("jbpm.user.group.mapping", "classpath:/usergroups.properties");
		System.setProperty("jbpm.usergroup.callback", "org.jbpm.task.identity.DefaultUserGroupCallbackImpl");
	    context = new ClassPathXmlApplicationContext("classpath:/META-INF/spring/jbpm-config.xml");
	    workflowService = context.getBean(WorkflowService.class);
	}
	
	@Test
	public void loadLocalTaskService(){
		assertNotNull(workflowService);
		ProcessInstance instance = workflowService.createTrainingAndStartWorkflow();
		assertNotNull(instance);
		assertNotNull(instance.getId());
		System.out.println(instance.getProcessId());
		System.out.println(instance.getState());
		System.out.println(workflowService.getTasksAssignedToUser());
	}
	
	public void testTaskAssignment(){
		List<TaskSummary> tasks = localTaskService.getTasksAssignedAsPotentialOwner("mayank", "en-UK");
		tasks = localTaskService.getTasksAssignedAsPotentialOwner(null, "en-UK");
		assertNotNull(tasks);
		assertEquals(1, tasks.size());
	}
	
}